Index: XIOS/dev/branch_yushan/src/registry.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/registry.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/registry.cpp	(revision 1037)
@@ -4,4 +4,5 @@
 #include <fstream>
 #include <sstream>
+
 
 namespace xios
@@ -221,8 +222,9 @@
 
     int* sizes=new int[mpiSize] ;
-    CBufferOut localBuffer(this->size()) ;
+    size_t st = this->size();
+    CBufferOut localBuffer(st) ;
     this->toBuffer(localBuffer) ;
     int localSize=localBuffer.count() ;
-    MPI_Gather(&localSize,1,MPI_INT,sizes,1,MPI_INT,0,comm) ;
+    MPI_Gather(&localSize,1,MPI_INT,sizes,1,MPI_INT,0,comm) ;    
 
     char* globalBuffer ;
@@ -252,4 +254,5 @@
     }
     else  MPI_Gatherv(localBuffer.start(),localSize,MPI_CHAR,globalBuffer,sizes,displs,MPI_CHAR,0,comm) ;   
+    
     delete[] sizes ;
     
@@ -258,5 +261,5 @@
   void CRegistry::hierarchicalGatherRegistry(void)
   {
-    hierarchicalGatherRegistry(communicator) ;
+    //hierarchicalGatherRegistry(communicator) ;
   }
 
Index: XIOS/dev/branch_yushan/src/registry.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/registry.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/registry.hpp	(revision 1037)
@@ -6,4 +6,8 @@
 #include "mpi.hpp"
 #include "message.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
+
 
 // Those two headers can be replaced by the C++11 equivalent in the future
@@ -23,6 +27,9 @@
 
 /** Constructor, the communicator is used for bcast or gather operation between MPI processes */
+     
       CRegistry(const MPI_Comm& comm=MPI_COMM_WORLD) : communicator(comm) {}
-
+      
+     
+      
 /** Copy constructor */
       CRegistry(const CRegistry& reg) ;
Index: XIOS/dev/branch_yushan/src/server.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/server.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/server.cpp	(revision 1037)
@@ -9,5 +9,5 @@
 #include <boost/functional/hash.hpp>
 #include <boost/algorithm/string.hpp>
-#include "mpi.hpp"
+//#include "mpi.hpp"
 #include "tracer.hpp"
 #include "timer.hpp"
@@ -26,21 +26,14 @@
     bool CServer::finished=false ;
     bool CServer::is_MPI_Initialized ;
+
+    
     CEventScheduler* CServer::eventScheduler = 0;
    
     void CServer::initialize(void)
     {
-      int initialized ;
-      MPI_Initialized(&initialized) ;
-      if (initialized) is_MPI_Initialized=true ;
-      else is_MPI_Initialized=false ;
-
       // Not using OASIS
       if (!CXios::usingOasis)
       {
 
-        if (!is_MPI_Initialized)
-        {
-          MPI_Init(NULL, NULL);
-        }
         CTimer::get("XIOS").resume() ;
 
@@ -50,5 +43,5 @@
         unsigned long* hashAll ;
 
-//        int rank ;
+
         int size ;
         int myColor ;
@@ -77,6 +70,9 @@
 
         myColor=colors[hashServer] ;
-        MPI_Comm_split(MPI_COMM_WORLD,myColor,rank,&intraComm) ;
-
+
+
+        MPI_Comm_split(CXios::globalComm,myColor,rank,&intraComm) ;
+
+        
         int serverLeader=leaders[hashServer] ;
         int clientLeader;
@@ -96,4 +92,5 @@
              MPI_Intercomm_create(intraComm,0,CXios::globalComm,clientLeader,0,&newComm) ;
              interComm.push_back(newComm) ;
+             printf("after inter create, interComm.size = %lu\n", interComm.size());
            }
          }
@@ -104,5 +101,4 @@
       else
       {
-//        int rank ,size;
         int size;
         if (!is_MPI_Initialized) oasis_init(CXios::xiosCodeId);
@@ -148,9 +144,13 @@
      
       delete eventScheduler ;
+      
+      
 
       for (std::list<MPI_Comm>::iterator it = contextInterComms.begin(); it != contextInterComms.end(); it++)
         MPI_Comm_free(&(*it));
+
       for (std::list<MPI_Comm>::iterator it = interComm.begin(); it != interComm.end(); it++)
         MPI_Comm_free(&(*it));
+
       MPI_Comm_free(&intraComm);
 
@@ -158,6 +158,8 @@
       {
         if (CXios::usingOasis) oasis_finalize();
-        else MPI_Finalize() ;
+        else  {MPI_Finalize() ; printf("CServer::finalize called MPI_finalize\n");}
       }
+
+      
       report(0)<<"Performance report : Time spent for XIOS : "<<CTimer::get("XIOS server").getCumulatedTime()<<endl  ;
       report(0)<<"Performance report : Time spent in processing events : "<<CTimer::get("Process events").getCumulatedTime()<<endl  ;
@@ -174,17 +176,23 @@
          if (isRoot)
          {
-           listenContext();
-           if (!finished) listenFinalize() ;
+           listenContext(); 
+           if (!finished) listenFinalize() ; 
          }
          else
          {
-           listenRootContext();
-           if (!finished) listenRootFinalize() ;
-         }
-
+           listenRootContext(); 
+           if (!finished) 
+           {
+             listenRootFinalize() ; 
+           }
+         }
+         
          contextEventLoop() ;
          if (finished && contextList.empty()) stop=true ;
+         
          eventScheduler->checkEvent() ;
        }
+       
+       
        CTimer::get("XIOS server").suspend() ;
      }
@@ -195,4 +203,5 @@
         int msg ;
         int flag ;
+        
 
         for(it=interComm.begin();it!=interComm.end();it++)
@@ -205,5 +214,7 @@
            {
               MPI_Recv(&msg,1,MPI_INT,0,0,*it,&status) ;
+              printf(" CServer : Receive client finalize\n");
               info(20)<<" CServer : Receive client finalize"<<endl ;
+
               MPI_Comm_free(&(*it));
               interComm.erase(it) ;
@@ -234,5 +245,5 @@
         MPI_Status status ;
         int msg ;
-
+        
         traceOff() ;
         MPI_Iprobe(0,4,intraComm, &flag, &status) ;
@@ -249,24 +260,30 @@
 
        MPI_Status status ;
-       int flag ;
-       static char* buffer ;
+       int flag = false ;
+       static void* buffer ;
        static MPI_Request request ;
        static bool recept=false ;
        int rank ;
-       int count ;
+       int count ; 
 
        if (recept==false)
-       {
+       {      
          traceOff() ;
          MPI_Iprobe(MPI_ANY_SOURCE,1,CXios::globalComm, &flag, &status) ;
          traceOn() ;
+         
          if (flag==true)
          {
+           #ifdef _usingMPI
            rank=status.MPI_SOURCE ;
+           #elif _usingEP
+           rank= status.ep_src ;
+           #endif
            MPI_Get_count(&status,MPI_CHAR,&count) ;
            buffer=new char[count] ;
-           MPI_Irecv((void*)buffer,count,MPI_CHAR,rank,1,CXios::globalComm,&request) ;
+           MPI_Irecv(buffer,count,MPI_CHAR,rank,1,CXios::globalComm,&request) ;
            recept=true ;
          }
+          
        }
        else
@@ -277,7 +294,13 @@
          if (flag==true)
          {
+           #ifdef _usingMPI
            rank=status.MPI_SOURCE ;
+           #elif _usingEP
+           rank= status.ep_src ;
+           #endif
            MPI_Get_count(&status,MPI_CHAR,&count) ;
-           recvContextMessage((void*)buffer,count) ;
+           recvContextMessage(buffer,count) ;
+           printf("listerContext register context OK, interComm size = %lu\n", interComm.size());
+           
            delete [] buffer ;
            recept=false ;
@@ -322,4 +345,5 @@
          MPI_Waitall(size-1,requests,status) ;
          registerContext(buff,count,it->second.leaderRank) ;
+         printf("recvContextMessage register context OK\n");
 
          recvContextId.erase(it) ;
@@ -335,5 +359,5 @@
        MPI_Status status ;
        int flag ;
-       static char* buffer ;
+       static void* buffer ;
        static MPI_Request request ;
        static bool recept=false ;
@@ -341,4 +365,5 @@
        int count ;
        const int root=0 ;
+       
 
        if (recept==false)
@@ -351,5 +376,5 @@
            MPI_Get_count(&status,MPI_CHAR,&count) ;
            buffer=new char[count] ;
-           MPI_Irecv((void*)buffer,count,MPI_CHAR,root,2,intraComm,&request) ;
+           MPI_Irecv(buffer,count,MPI_CHAR,root,2,intraComm,&request) ;
            recept=true ;
          }
@@ -361,5 +386,6 @@
          {
            MPI_Get_count(&status,MPI_CHAR,&count) ;
-           registerContext((void*)buffer,count) ;
+           registerContext(buffer,count) ;
+           printf("listenRootContext register context OK, interComm size = %lu\n", interComm.size());
            delete [] buffer ;
            recept=false ;
@@ -381,4 +407,5 @@
 
        MPI_Comm contextIntercomm;
+       
        MPI_Intercomm_create(intraComm,0,CXios::globalComm,leaderRank,10+leaderRank,&contextIntercomm);
 
@@ -386,11 +413,18 @@
        MPI_Intercomm_merge(contextIntercomm,1,&inter);
        MPI_Barrier(inter);
+       
 
        CContext* context=CContext::create(contextId);
        contextList[contextId]=context;
        context->initServer(intraComm,contextIntercomm);
+       
+       
 
        contextInterComms.push_back(contextIntercomm);
+       
+       
        MPI_Comm_free(&inter);
+       
+       printf(" ****   server: register context OK\n");
      }
 
Index: XIOS/dev/branch_yushan/src/server.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/server.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/server.hpp	(revision 1037)
@@ -7,4 +7,8 @@
 #include "mpi.hpp"
 #include "event_scheduler.hpp"
+
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
 
 namespace xios
Index: XIOS/dev/branch_yushan/src/test/test_client.f90
===================================================================
--- XIOS/dev/branch_yushan/src/test/test_client.f90	(revision 1036)
+++ XIOS/dev/branch_yushan/src/test/test_client.f90	(revision 1037)
@@ -35,13 +35,14 @@
 
   CALL MPI_INIT(ierr)
-
   CALL init_wait
-
-!!! XIOS Initialization (get the local communicator)
-
+  
   CALL xios_initialize(id,return_comm=comm)
+  
+  print*, "test_client xios_initialize OK"
 
   CALL MPI_COMM_RANK(comm,rank,ierr)
+  print*, "test_client MPI_COMM_RANK OK"
   CALL MPI_COMM_SIZE(comm,size,ierr)
+  
 
   DO j=1,nj_glo
@@ -70,9 +71,15 @@
   lat(:,:)=lat_glo(ibegin+1:iend+1,jbegin+1:jend+1)
   field_A(1:ni,1:nj,:)=field_A_glo(ibegin+1:iend+1,jbegin+1:jend+1,:)
+  
+  CALL xios_context_initialize("test",comm)
 
-  CALL xios_context_initialize("test",comm)
   CALL xios_get_handle("test",ctx_hdl)
+  print*, "Client xios_get_handle OK"
   CALL xios_set_current_context(ctx_hdl)
-
+  print*, "Client xios_set_current_handle OK"  
+  
+  
+  
+  
   CALL xios_get_calendar_type(calendar_type)
   PRINT *, "calendar_type = ", calendar_type
@@ -91,7 +98,8 @@
   CALL xios_add_child(file_hdl,field_hdl)
   CALL xios_set_attr(field_hdl,field_ref="field_A_zoom",name="field_C")
-
+  
   dtime%second = 3600
   CALL xios_set_timestep(dtime)
+  print*, "Client xios_set_timestep OK"  
 
   ! The calendar is created as soon as the calendar type is defined. This way
@@ -119,20 +127,26 @@
   ni=0 ; lonvalue(:,:)=0;
   CALL xios_get_domain_attr("domain_A",ni=ni,lonvalue_2D=lonvalue)
-
   print *,"ni",ni
-  print *,"lonvalue",lonvalue;
+  !print *,"lonvalue",lonvalue;
 
   CALL xios_is_defined_field_attr("field_A",enabled=ok)
   PRINT *,"field_A : attribute enabled is defined ? ",ok
+  
   CALL xios_close_context_definition()
+  print*, "xios_close_context_definition OK"  
 
   PRINT*,"field field_A is active ? ",xios_field_is_active("field_A")
-  DO ts=1,24*10
+  !DO ts=1,24*10
+  DO ts=1,24
     CALL xios_update_calendar(ts)
+    print*, "xios_update_calendar OK, ts = ", ts
     CALL xios_send_field("field_A",field_A)
-    CALL wait_us(5000) ;
+    print*, "xios_send_field OK, ts = ", ts
+    CALL wait_us(5000)
   ENDDO
+  
 
   CALL xios_context_finalize()
+  print*, "xios_context_finalize OK"  
 
   DEALLOCATE(lon, lat, field_A, lonvalue)
Index: XIOS/dev/branch_yushan/src/test/test_regular.f90
===================================================================
--- XIOS/dev/branch_yushan/src/test/test_regular.f90	(revision 1036)
+++ XIOS/dev/branch_yushan/src/test/test_regular.f90	(revision 1037)
@@ -18,5 +18,5 @@
   INTEGER :: comm  
   INTEGER :: ierr
-  INTEGER :: sizeComm, rank    ! SIZE is a fortran function
+  INTEGER :: size, rank
 
   INTEGER :: nlon = 100 
@@ -94,19 +94,19 @@
 
   CALL MPI_COMM_RANK(comm,rank,ierr)
-  CALL MPI_COMM_SIZE(comm,sizeComm,ierr)
+  CALL MPI_COMM_SIZE(comm,size,ierr)
 
-  IF (MOD(ncell, sizeComm) == 0) THEN
-    ni = ncell/sizeComm
+  IF (MOD(ncell, size) == 0) THEN
+    ni = ncell/size
     ibegin = rank*ni
   ELSE
-    IF (rank < MOD(ncell, sizeComm)) THEN
-      ni = ncell/sizeComm + 1
-      ibegin = rank*(ncell/sizeComm + 1)
+    IF (rank < MOD(ncell, size)) THEN
+      ni = ncell/size + 1
+      ibegin = rank*(ncell/size + 1)
     ELSE
-      ni = ncell/sizeComm
-      IF (rank == MOD(ncell, sizeComm)) THEN
-        ibegin = rank*(ncell/sizeComm + 1)
+      ni = ncell/size
+      IF (rank == MOD(ncell, size)) THEN
+        ibegin = rank*(ncell/size + 1)
       ELSE
-        ibegin = MOD(ncell,sizeComm)*(ncell/sizeComm + 1) + (rank-MOD(ncell,sizeComm))*ncell/sizeComm
+        ibegin = MOD(ncell,size)*(ncell/size + 1) + (rank-MOD(ncell,size))*ncell/size
       END IF
     END IF
@@ -118,8 +118,8 @@
   ALLOCATE(bounds_lat(4,ni))
   ALLOCATE(field_temp(ni,ntime)) 
-  lon = lon_glo(1+ibegin:ibegin+ni)
-  lat = lat_glo(1+ibegin:ibegin+ni)
-  bounds_lon(:,:) = bounds_lon_glo(:,1+ibegin:ibegin+ni)
-  bounds_lat(:,:) = bounds_lat_glo(:,1+ibegin:ibegin+ni)
+  lon = lon_glo(1+ibegin:1+ibegin+ni)
+  lat = lat_glo(1+ibegin:1+ibegin+ni)
+  bounds_lon(:,:) = bounds_lon_glo(:,1+ibegin:1+ibegin+ni)
+  bounds_lat(:,:) = bounds_lat_glo(:,1+ibegin:1+ibegin+ni)
   field_temp(:,:) = rank
 
Index: XIOS/dev/branch_yushan/src/test/test_remap.f90
===================================================================
--- XIOS/dev/branch_yushan/src/test/test_remap.f90	(revision 1036)
+++ XIOS/dev/branch_yushan/src/test/test_remap.f90	(revision 1037)
@@ -91,7 +91,6 @@
     IF (MOD(i,10)==0) THEN
       src_mask_2D(i)=.FALSE.
-      src_field_2D(i) = 100000
     ELSE
-      src_mask_2D(i)=.TRUE.      
+      src_mask_2D(i)=.TRUE.
     ENDIF
   ENDDO
@@ -100,16 +99,9 @@
     lval(i) = i*100
     src_field_pression(:,i) = i * 100
-    IF (MOD(i,3)==0) THEN
-      ! src_field_pression(:,i) = 100000
-      src_field_3D(:,i) = 100000
-    ELSE
-      ! src_field_pression(:,i) = i * 100
-      src_field_3D(:,i) = src_field_3D(:,i) + i * 10 
-    ENDIF
-    ! src_field_3D(:,i) = src_field_3D(:,i) + i * 10    
+    src_field_3D(:,i) = src_field_3D(:,i) + i * 10    
   ENDDO
 
   DO i=1,llm2
-    src_field_4D(:,:,i) = src_field_3D(:,:) + i * 100
+    src_field_4D(:,:,i) = src_field_3D(:,:)
   ENDDO
 
@@ -192,5 +184,4 @@
     CALL xios_send_field("src_field_2D_clone",src_field_2D)
     CALL xios_send_field("src_field_3D",src_field_3D)
-    CALL xios_send_field("src_field_3D_clone",src_field_3D)
     CALL xios_send_field("src_field_4D",src_field_4D)
     CALL xios_send_field("src_field_3D_pression",src_field_pression)
Index: XIOS/dev/branch_yushan/src/transformation/Functions/average_reduction.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/average_reduction.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/average_reduction.cpp	(revision 1037)
@@ -3,10 +3,9 @@
    \author Ha NGUYEN
    \since 8 Sep 2016
-   \date 9 Jan 2017
+   \date 8 Sep 2016
 
    \brief average reduction
  */
 #include "average_reduction.hpp"
-#include "utils.hpp"
 
 namespace xios {
@@ -30,54 +29,25 @@
                                        const double* dataInput,
                                        CArray<double,1>& dataOut,
-                                       std::vector<bool>& flagInitial,
-                                       const double& defaultValue)
+                                       std::vector<bool>& flagInitial)
 {
   if (resetWeight_) { weights_.resize(flagInitial.size()); weights_ = 1.0; resetWeight_ = false; }
-  bool hasMissingValue = NumTraits<double>::isnan(defaultValue);
 
-  if (hasMissingValue)
+  int nbLocalIndex = localIndex.size();
+  int currentlocalIndex = 0;
+  double currentWeight  = 0.0;
+  for (int idx = 0; idx < nbLocalIndex; ++idx)
   {
-    int nbLocalIndex = localIndex.size();
-    int currentlocalIndex = 0;
-    double currentWeight  = 0.0;
-    for (int idx = 0; idx < nbLocalIndex; ++idx)
+    currentlocalIndex = localIndex[idx].first;
+    currentWeight     = localIndex[idx].second;
+
+    if (flagInitial[currentlocalIndex])
     {
-      currentlocalIndex = localIndex[idx].first;
-      currentWeight     = localIndex[idx].second;
-      if (!NumTraits<double>::isnan(*(dataInput + idx)))
-      {
-        if (flagInitial[currentlocalIndex])
-        {
-          dataOut(currentlocalIndex) = *(dataInput + idx);
-          flagInitial[currentlocalIndex] = false;
-        }
-        else
-        {
-          dataOut(currentlocalIndex)  += *(dataInput + idx);
-          weights_(currentlocalIndex) += 1.0;
-        }
-      }
+      dataOut(currentlocalIndex) = *(dataInput + idx);
+      flagInitial[currentlocalIndex] = false;
     }
-  }
-  else
-  {
-    int nbLocalIndex = localIndex.size();
-    int currentlocalIndex = 0;
-    double currentWeight  = 0.0;
-    for (int idx = 0; idx < nbLocalIndex; ++idx)
+    else
     {
-      currentlocalIndex = localIndex[idx].first;
-      currentWeight     = localIndex[idx].second;
-
-      if (flagInitial[currentlocalIndex])
-      {
-        dataOut(currentlocalIndex) = *(dataInput + idx);
-        flagInitial[currentlocalIndex] = false;
-      }
-      else
-      {
-        dataOut(currentlocalIndex)  += *(dataInput + idx);
-        weights_(currentlocalIndex) += 1.0;
-      }
+      dataOut(currentlocalIndex)  += *(dataInput + idx);
+      weights_(currentlocalIndex) += 1.0;
     }
   }
Index: XIOS/dev/branch_yushan/src/transformation/Functions/average_reduction.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/average_reduction.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/average_reduction.hpp	(revision 1037)
@@ -26,6 +26,5 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     std::vector<bool>& flagInitial);
 
   virtual void updateData(CArray<double,1>& dataOut);
Index: XIOS/dev/branch_yushan/src/transformation/Functions/extract.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/extract.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/extract.cpp	(revision 1037)
@@ -29,6 +29,5 @@
                                        const double* dataInput,
                                        CArray<double,1>& dataOut,
-                                       std::vector<bool>& flagInitial,
-                                       const double& defaultValue)
+                                       std::vector<bool>& flagInitial)
 {
   int nbLocalIndex = localIndex.size();
Index: XIOS/dev/branch_yushan/src/transformation/Functions/extract.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/extract.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/extract.hpp	(revision 1037)
@@ -26,6 +26,5 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     std::vector<bool>& flagInitial);
 
   virtual ~CExtractReductionAlgorithm() {}
Index: XIOS/dev/branch_yushan/src/transformation/Functions/max_reduction.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/max_reduction.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/max_reduction.cpp	(revision 1037)
@@ -8,5 +8,4 @@
  */
 #include "max_reduction.hpp"
-#include "utils.hpp"
 
 namespace xios {
@@ -30,46 +29,21 @@
                                    const double* dataInput,
                                    CArray<double,1>& dataOut,
-                                   std::vector<bool>& flagInitial,
-                                   const double& defaultValue)
+                                   std::vector<bool>& flagInitial)
 {
-  bool hasMissingValue = NumTraits<double>::isnan(defaultValue);
-
-  if (hasMissingValue)
+  int nbLocalIndex = localIndex.size();
+  int currentlocalIndex = 0;
+  double currentWeight  = 0.0;
+  for (int idx = 0; idx < nbLocalIndex; ++idx)
   {
-    int nbLocalIndex = localIndex.size();
-    int currentlocalIndex = 0;    
-    for (int idx = 0; idx < nbLocalIndex; ++idx)
+    currentlocalIndex = localIndex[idx].first;
+    currentWeight     = localIndex[idx].second;
+    if (flagInitial[currentlocalIndex])
     {
-      currentlocalIndex = localIndex[idx].first;      
-      if (!NumTraits<double>::isnan(*(dataInput + idx)))
-      {
-        if (flagInitial[currentlocalIndex])
-        {
-          dataOut(currentlocalIndex) = *(dataInput + idx);
-          flagInitial[currentlocalIndex] = false;
-        }
-        else
-        {
-          dataOut(currentlocalIndex) = std::max(*(dataInput + idx), dataOut(currentlocalIndex));
-        }
-      }
+      dataOut(currentlocalIndex) = *(dataInput + idx);
+      flagInitial[currentlocalIndex] = false;
     }
-  }
-  else
-  {
-    int nbLocalIndex = localIndex.size();
-    int currentlocalIndex = 0;    
-    for (int idx = 0; idx < nbLocalIndex; ++idx)
+    else
     {
-      currentlocalIndex = localIndex[idx].first;      
-      if (flagInitial[currentlocalIndex])
-      {
-        dataOut(currentlocalIndex) = *(dataInput + idx);
-        flagInitial[currentlocalIndex] = false;
-      }
-      else
-      {
-        dataOut(currentlocalIndex) = std::max(*(dataInput + idx), dataOut(currentlocalIndex));
-      }
+      dataOut(currentlocalIndex) = std::max(*(dataInput + idx), dataOut(currentlocalIndex));
     }
   }
Index: XIOS/dev/branch_yushan/src/transformation/Functions/max_reduction.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/max_reduction.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/max_reduction.hpp	(revision 1037)
@@ -26,6 +26,5 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     std::vector<bool>& flagInitial);
 
   virtual ~CMaxReductionAlgorithm() {}
Index: XIOS/dev/branch_yushan/src/transformation/Functions/min_reduction.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/min_reduction.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/min_reduction.cpp	(revision 1037)
@@ -3,10 +3,9 @@
    \author Ha NGUYEN
    \since 27 June 2016
-   \date 9 Jan 2017
+   \date 27 June 2016
 
    \brief min reduction
  */
 #include "min_reduction.hpp"
-#include "utils.hpp"
 
 namespace xios {
@@ -30,46 +29,19 @@
                                    const double* dataInput,
                                    CArray<double,1>& dataOut,
-                                   std::vector<bool>& flagInitial,
-                                   const double& defaultValue)
+                                   std::vector<bool>& flagInitial)
 {
-  bool hasMissingValue = NumTraits<double>::isnan(defaultValue);
-
-  if (hasMissingValue)
+  int nbLocalIndex = localIndex.size();
+  int currentlocalIndex = 0;
+  for (int idx = 0; idx < nbLocalIndex; ++idx)
   {
-    int nbLocalIndex = localIndex.size();
-    int currentlocalIndex = 0;
-    for (int idx = 0; idx < nbLocalIndex; ++idx)
+    currentlocalIndex = localIndex[idx].first;
+    if (flagInitial[currentlocalIndex])
     {
-      currentlocalIndex = localIndex[idx].first;
-      if (!NumTraits<double>::isnan(*(dataInput + idx)))
-      {
-        if (flagInitial[currentlocalIndex])
-        {
-          dataOut(currentlocalIndex) = *(dataInput + idx);
-          flagInitial[currentlocalIndex] = false;
-        }
-        else
-        {
-          dataOut(currentlocalIndex) = std::min(*(dataInput + idx), dataOut(currentlocalIndex));
-        }
-      }
+      dataOut(currentlocalIndex) = *(dataInput + idx);
+      flagInitial[currentlocalIndex] = false;
     }
-  }
-  else
-  {
-    int nbLocalIndex = localIndex.size();
-    int currentlocalIndex = 0;
-    for (int idx = 0; idx < nbLocalIndex; ++idx)
+    else
     {
-      currentlocalIndex = localIndex[idx].first;
-      if (flagInitial[currentlocalIndex])
-      {
-        dataOut(currentlocalIndex) = *(dataInput + idx);
-        flagInitial[currentlocalIndex] = false;
-      }
-      else
-      {
-        dataOut(currentlocalIndex) = std::min(*(dataInput + idx), dataOut(currentlocalIndex));
-      }
+      dataOut(currentlocalIndex) = std::min(*(dataInput + idx), dataOut(currentlocalIndex));
     }
   }
Index: XIOS/dev/branch_yushan/src/transformation/Functions/min_reduction.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/min_reduction.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/min_reduction.hpp	(revision 1037)
@@ -26,6 +26,5 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     std::vector<bool>& flagInitial);
 
   virtual ~CMinReductionAlgorithm() {}
Index: XIOS/dev/branch_yushan/src/transformation/Functions/reduction.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/reduction.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/reduction.hpp	(revision 1037)
@@ -45,6 +45,5 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue) = 0;
+                     std::vector<bool>& flagInitial) = 0;
   /*!
     Update local data 
Index: XIOS/dev/branch_yushan/src/transformation/Functions/sum_reduction.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/sum_reduction.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/sum_reduction.cpp	(revision 1037)
@@ -3,10 +3,9 @@
    \author Ha NGUYEN
    \since 27 June 2016
-   \date 9 Jan 2017
+   \date 27 June 2016
 
    \brief sum reduction
  */
 #include "sum_reduction.hpp"
-#include "utils.hpp"
 
 namespace xios {
@@ -30,45 +29,21 @@
                                    const double* dataInput,
                                    CArray<double,1>& dataOut,
-                                   std::vector<bool>& flagInitial,
-                                   const double& defaultValue)
+                                   std::vector<bool>& flagInitial)
 {
-  bool hasMissingValue = NumTraits<double>::isnan(defaultValue);
-  if (hasMissingValue)
+  int nbLocalIndex = localIndex.size();
+  int currentlocalIndex = 0;
+  double currentWeight  = 0.0;
+  for (int idx = 0; idx < nbLocalIndex; ++idx)
   {
-    int nbLocalIndex = localIndex.size();
-    int currentlocalIndex = 0;    
-    for (int idx = 0; idx < nbLocalIndex; ++idx)
+    currentlocalIndex = localIndex[idx].first;
+    currentWeight     = localIndex[idx].second;
+    if (flagInitial[currentlocalIndex])
     {
-      currentlocalIndex = localIndex[idx].first;   
-      if (!NumTraits<double>::isnan(*(dataInput + idx)))
-      {   
-        if (flagInitial[currentlocalIndex])
-        {
-          dataOut(currentlocalIndex) = *(dataInput + idx);
-          flagInitial[currentlocalIndex] = false;
-        }
-        else
-        {
-          dataOut(currentlocalIndex) += *(dataInput + idx);
-        }
-      }
-    }    
-  }
-  else
-  {
-    int nbLocalIndex = localIndex.size();
-    int currentlocalIndex = 0;    
-    for (int idx = 0; idx < nbLocalIndex; ++idx)
+      dataOut(currentlocalIndex) = *(dataInput + idx);
+      flagInitial[currentlocalIndex] = false;
+    }
+    else
     {
-      currentlocalIndex = localIndex[idx].first;      
-      if (flagInitial[currentlocalIndex])
-      {
-        dataOut(currentlocalIndex) = *(dataInput + idx);
-        flagInitial[currentlocalIndex] = false;
-      }
-      else
-      {
-        dataOut(currentlocalIndex) += *(dataInput + idx);
-      }
+      dataOut(currentlocalIndex) += *(dataInput + idx);
     }
   }
Index: XIOS/dev/branch_yushan/src/transformation/Functions/sum_reduction.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/Functions/sum_reduction.hpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/Functions/sum_reduction.hpp	(revision 1037)
@@ -26,6 +26,5 @@
                      const double* dataInput,
                      CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     const double& defaultValue);
+                     std::vector<bool>& flagInitial);
 
   virtual ~CSumReductionAlgorithm() {}
Index: XIOS/dev/branch_yushan/src/transformation/axis_algorithm_extract_domain.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1037)
@@ -71,5 +71,5 @@
                                         const double& defaultValue)
 {
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, defaultValue);
+  reduction_->apply(localIndex, dataInput, dataOut, flagInitial);
 }
 
Index: XIOS/dev/branch_yushan/src/transformation/axis_algorithm_inverse.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/axis_algorithm_inverse.cpp	(revision 1036)
+++ XIOS/dev/branch_yushan/src/transformation/axis_algorithm_inverse.cpp	(revision 1037)
@@ -211,6 +211,7 @@
 
   status.resize(requests.size());
+  //printf("(%d) src/transformation/axis_algorithm_inverse 1st waitall\n", clientRank);
   MPI_Waitall(requests.size(), &requests[0], &status[0]);
-
+  //printf("(%d) src/transformation/axis_algorithm_inverse 1st waitall OK\n", clientRank);
 
   std::vector<MPI_Request>().swap(requests);
@@ -245,6 +246,8 @@
   }
   status.resize(requests.size());
+  //printf("(%d) src/transformation/axis_algorithm_inverse 2nd waitall\n", clientRank);
+
   MPI_Waitall(requests.size(), &requests[0], &status[0]);
-
+  //printf("(%d) src/transformation/axis_algorithm_inverse 2nd waitall OK\n", clientRank);
 
   size_t nGloAxisDest = axisDest_->n_glo.getValue() - 1;
